SoBumpMap(3)

NAME
SoBumpMap - The SoBumpMap class is used to map a bump map onto subsequent shapes.

SYNOPSIS

#include <Inventor/nodes/SoBumpMap.h>

Inherits SoNode.

  Public Types
enum Wrap { REPEAT = SoMultiTextureImageElement::REPEAT, CLAMP = SoMultiTextureImageElement::CLAMP }

  Public Member Functions
virtual SoType getTypeId (void) const
SoBumpMap (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
virtual void rayPick (SoRayPickAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFString filename
SoSFImage image
SoSFEnum wrapS
SoSFEnum wrapT

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoBumpMap ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)
virtual void notify (SoNotList *list)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoBumpMap class is used to map a bump map onto subsequent shapes. SoBumpMap has support for two types of maps. If the image is a three component (RGB) image, it will be treated as a normal map, where the red image component equals the X normal component, green equals Y, and blue is Z. See http://www.paulsprojects.net/tutorials/simplebump/simplebump.html for a nice introduction about bump mapping and normal maps.

If the image is a grayscale image, it will be treated as a height map, and automatically converted to a normal map.

For bump mapping to work with extension nodes for Coin, the SoShape::generatePrimitives() method must be correctly implemented for the shape. This is needed since tangent space coordinates needs to be calculated for each vertex in the shape. All shape nodes which are a standard part of Coin meets this criteria.

Bump mapping in Coin requires OpenGL 1.3, or the following OpenGL extensions: GL_ARB_multitexture, GL_ARB_texture_cube_map, GL_ARB_texture_env_combine and GL_ARB_texture_env_dot3 (or the corresponding EXT extensions). If the runtime system doesn't meet these requirements, Coin will post a warning and the bump map will simply be ignored.

GL_ARB_vertex_program and GL_ARB_fragment_program is required to get specular lighting on the bumps. If these extensions are not available, the bumps will be rendered with diffuse lighting only.

Bump mapped objects will be rendered with multiple rendering passes. One extra pass per light source for diffuse only bumps, and two extra passes per light source for diffuse and specular bumps. You can turn off specular lighting on the bumps by setting specularColor to (0.0, 0.0, 0.0).

FILE FORMAT/DEFAULTS:

BumpMap {
    filename ""
    image 0 0 0
    wrapS REPEAT
    wrapT REPEAT
}

Since
    Coin 2.2

Member Enumeration Documentation

  enum SoBumpMap::Wrap
Enumeration of wrapping strategies which can be used when the bump map doesn't cover the full extent of the geometry.

Enumerator

REPEAT
    Repeat bump map when coordinate is not between 0 and 1.

CLAMP
    Clamp coordinate between 0 and 1.

Constructor & Destructor Documentation

  SoBumpMap::SoBumpMap (void)
Constructor.

  SoBumpMap::~SoBumpMap () [protected], [virtual]
Destructor. Frees up internal resources used to store texture image data.

Member Function Documentation

  SoType SoBumpMap::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoBumpMap::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoBumpMap::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoBumpMap::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoBumpMap::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoBumpMap::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoBumpMap::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoBumpMap::rayPick (SoRayPickAction * action) [virtual]
Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

  SbBool SoBumpMap::readInstance (SoInput * in, unsigned short flags) [protected], [virtual]
This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

TRUE or FALSE is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning FALSE.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

  void SoBumpMap::notify (SoNotList * l) [protected], [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Member Data Documentation

  SoSFString SoBumpMap::filename
Bump map (or normal map) filename, referring to a file on disk in a supported image bitmap format. See SoBumpMap::filename for more information.

  SoSFImage SoBumpMap::image
Inline image data. Defaults to contain an empty bump map.

  SoSFEnum SoBumpMap::wrapS
Wrapping strategy for the S coordinate when the bump map is narrower than the object to map onto.

Default value is SoBumpMap::REPEAT.

  SoSFEnum SoBumpMap::wrapT
Wrapping strategy for the T coordinate when the bump map is shorter than the object to map onto.

Default value is SoBumpMap::REPEAT.

Author

Generated automatically by Doxygen for Coin from the source code.